<!DOCTYPE html>
<meta charset="utf-8">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
<!-- Load d3.js -->
<script src="https://d3js.org/d3.v4.js"></script>
<style> @import url('https://fonts.googleapis.com/css2?family=Playfair+Display:wght@500&display=swap'); </style>
<!-- Color Scale -->
<script src="https://d3js.org/d3-scale-chromatic.v1.min.js"></script>
<title>Dating Apps- A study about safety of using dating apps</title>
<style type='text/css'>
  #sidecontent h4
    {
      font-size:1em;
      margin:0;
      padding:10px 3px 2px 15px;
    }
</style>

<body>
  <head>
    <h1>Public outlook of Dating apps over the years</h1>
    <style>
      h1{
        margin:auto;
        padding-top: 50px;
        padding-right: 30px;
        padding-bottom: 50px;
        padding-left: 80px;
        text-align: center;
        font-family: 'Playfair Display', serif;
        font-size: 9ch;
        }
    </style>
    
  </head>


<!-- Create a div where the graph will take place -->
<div id="my_dataviz" align="center"></div>
<div id="scatter_plot"></div>

<!-- <div id="bar_chart_interactive"></div> -->
<div id="sidecontent">
  <h2>Stacked bar chart</h2>
    <h4>It shows the quarterly and annual total number of reviews of tinder app. It proves the fact that the popularity of tinder app is slowly on it's decline since 2020. The orange represents the quarter 1 of the specific year, red representing the quarter 2, and so on. When all 4 quarters are stacked together, that represents the total number of review in that year.</h4>
  <br>
    <h2>Connected scatter graph</h2>
    <h4>It shows the average rating of 3 major dating apps, Tinder, Bumble and Hinge. It represents the customer satisfation over the years and the app's trend. The green scatter plot is Tinder, Orange is bumble and blue is hinge. </h4>
</div>

</body>

<script>
    // set the dimensions and margins of the graph
    var margin = {top: 10, right: 30, bottom: 20, left: 50},
        width = 460 - margin.left - margin.right,
        height = 400 - margin.top - margin.bottom;
    
    // append the svg object to the body of the page
    var svg = d3.select("#my_dataviz")
      .append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
      .append("g")
        .attr("transform",
              "translate(" + margin.left + "," + margin.top + ")");
    
    // Parse the Data
    d3.csv("data/data.csv", function(data) {
    
      // List of subgroups = header of the csv files = soil condition here
      var subgroups = data.columns.slice(1)
    
      // List of groups = species here = value of the first column called group -> I show them on the X axis
      var groups = d3.map(data, function(d){return(d.group)}).keys()
    
      // Add X axis
      var x = d3.scaleBand()
          .domain(groups)
          .range([0, width])
          .padding([0.2])
      svg.append("g")
        .attr("transform", "translate(0," + height + ")")
        .call(d3.axisBottom(x).tickSizeOuter(0));
    
      // Add Y axis
      var y = d3.scaleLinear()
        .domain([0, 100000])
        .range([ height, 0 ]);
      svg.append("g")
        .call(d3.axisLeft(y));
    
      // color palette = one color per subgroup
      var color = d3.scaleOrdinal()
        .domain(subgroups)
        .range(['#fa9c6e','#c1657e','#86507b','#393a60'])
    
      //stack the data? --> stack per subgroup
      var stackedData = d3.stack()
        .keys(subgroups)
        (data)
    
      // Show the bars
      svg.append("g")
        .selectAll("g")
        // Enter in the stack data = loop key per key = group per group
        .data(stackedData)
        .enter().append("g")
          .attr("fill", function(d) { return color(d.key); })
          .selectAll("rect")
          // enter a second time = loop subgroup per subgroup to add all rectangles
          .data(function(d) { return d; })
          .enter().append("rect")
            .attr("x", function(d) { return x(d.data.group); })
            .attr("y", function(d) { return y(d[1]); })
            .attr("height", function(d) { return y(d[0]) - y(d[1]); })
            .attr("width",x.bandwidth())
    })
    
    </script>
<script>

  // set the dimensions and margins of the graph
  var margin = {top: 10, right: 100, bottom: 30, left: 30},
      width = 460 - margin.left - margin.right,
      height = 400 - margin.top - margin.bottom;
  
  // append the svg object to the body of the page
  var svg2 = d3.select("#my_dataviz")
    .append("svg")
      .attr("width", width + margin.left + margin.right)
      .attr("height", height + margin.top + margin.bottom)
    .append("g")
      .attr("transform",
            "translate(" + margin.left + "," + margin.top + ")");
  
  //Read the data
  d3.csv("data/rating.csv", function(data) {
  
      // List of groups (here I have one group per column)
      var allGroup = ["Tinder", "Bumble", "Hinge"]
  
      // Reformat the data: we need an array of arrays of {x, y} tuples
      var dataReady = allGroup.map( function(grpName) { // .map allows to do something for each element of the list
        return {
          name: grpName,
          values: data.map(function(d) {
            return {time: d.time, value: +d[grpName]};
          })
        };
      });
      // I strongly advise to have a look to dataReady with
      // console.log(dataReady)
  
      // A color scale: one color for each group
      var myColor = d3.scaleOrdinal()
        .domain(allGroup)
        .range(d3.schemeSet2);
  
      // Add X axis --> it is a date format
      var x = d3.scaleLinear()
        .domain([2013,2022])
        .range([ 0, width ]);
      svg2.append("g")
        .attr("transform", "translate(0," + height + ")")
        .call(d3.axisBottom(x));
  
      // Add Y axis
      var y = d3.scaleLinear()
        .domain( [0,5])
        .range([ height, 0 ]);
      svg2.append("g")
        .call(d3.axisLeft(y));
  
      // Add the lines
      var line = d3.line()
        .x(function(d) { return x(+d.time) })
        .y(function(d) { return y(+d.value) })
      svg2.selectAll("myLines")
        .data(dataReady)
        .enter()
        .append("path")
          .attr("class", function(d){ return d.name })
          .attr("d", function(d){ return line(d.values) } )
          .attr("stroke", function(d){ return myColor(d.name) })
          .style("stroke-width", 4)
          .style("fill", "none")
  
      // Add the points
      svg2
        // First we need to enter in a group
        .selectAll("myDots")
        .data(dataReady)
        .enter()
          .append('g')
          .style("fill", function(d){ return myColor(d.name) })
          .attr("class", function(d){ return d.name })
        // Second we need to enter in the 'values' part of this group
        .selectAll("myPoints")
        .data(function(d){ return d.values })
        .enter()
        .append("circle")
          .attr("cx", function(d) { return x(d.time) } )
          .attr("cy", function(d) { return y(d.value) } )
          .attr("r", 5)
          .attr("stroke", "white")
  
      // Add a label at the end of each line
      svg2
        .selectAll("myLabels")
        .data(dataReady)
        .enter()
          .append('g')
          .append("text")
            .attr("class", function(d){ return d.name })
            .datum(function(d) { return {name: d.name, value: d.values[d.values.length - 1]}; }) // keep only the last value of each time series
            .attr("transform", function(d) { return "translate(" + x(d.value.time) + "," + y(d.value.value) + ")"; }) // Put the text at the position of the last point
            .attr("x", 12) // shift the text a bit more right
            .text(function(d) { return d.name; })
            .style("fill", function(d){ return myColor(d.name) })
            .style("font-size", 15)
  
      // Add a legend (interactive)
      svg2
        .selectAll("myLegend")
        .data(dataReady)
        .enter()
          .append('g')
          .append("text")
            .attr('x', function(d,i){ return 30 + i*60})
            .attr('y', 30)
            .text(function(d) { return d.name; })
            .style("fill", function(d){ return myColor(d.name) })
            .style("font-size", 15)
          .on("click", function(d){
            // is the element currently visible ?
            currentOpacity = d3.selectAll("." + d.name).style("opacity")
            // Change the opacity: from 0 to 1 or from 1 to 0
            d3.selectAll("." + d.name).transition().style("opacity", currentOpacity == 1 ? 0:1)
  
          })
  })
  
  
  </script>
  <div id="bubble_chart" align="center"></div>

<style>
.node:hover{
  stroke-width: 3px !important;
  opacity: 1 !important;
}
</style>
 <script src="bubblechart.js"></script>
 <br>
<br>
<div id="sidecontent">
<h2>Circular Packed Bubble Chart with Collision and Dragging Animation (and tooltip)</h2>
<h4>The animation makes this visualization very user-interactive. Scams have the highest mentions in the dating app confessions/ testimonials on Reddit, followed by catfishing.</h4>
</div>
<div id="bar_chart" align="center"> <button onclick="update('assault')">Assault</button>
  <button onclick="update('scam')">Scam</button>
  <button onclick="update('sexual assault')">sexual assault</button>
  <button onclick="update('robbed')">robbed</button>
  <button onclick="update('phishing')">phishing</button>
  <button onclick="update('robbed')">robbed</button></div>

<script src="multi_bar_chart.js"></script>  
<div id="sidecontent">
<h2>User interactive bar chart</h2>
<h4>It shows the annual total number of Reddit posts which have the crime mentioned in them. A general trend of increasing nature is observed for moost of the crimes and their mentions.
  (PS. Use the buttons to toggle between different crime categories. )
</h4>
</div>
<style>
  #sidecontent {
    margin:auto;
    padding-top: 50px;
    padding-right: 30px;
    padding-left: 20px;
    font-family: 'Playfair Display', serif;
    font-size: 3ch;
    font-weight:bold;
  }
  #sidecontent h2{
    font-weight: bold;
  }
</style>